<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: Output Files of Simulations</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">


<h1><a class="anchor" id="output">Output Files of Simulations </a></h1><hr/>
<p><b>Sections:</b></p>
<ul>
<li><a class="el" href="output.html#project_png">project.INP.X.png</a></li>
<li><a class="el" href="output.html#project_d">project.INP.d</a></li>
<li><a class="el" href="output.html#project_datmsh">project.INP.datmsh</a></li>
<li><a class="el" href="output.html#project_fedat">project.INP.fedat</a></li>
<li><a class="el" href="output.html#project_felog">project.INP.felog</a></li>
<li><a class="el" href="output.html#project_femsh">project.INP.femsh</a></li>
<li><a class="el" href="output.html#project_gz">project.INP.gz</a></li>
<li><a class="el" href="output.html#project_inp_inp">project.INP.inp</a></li>
<li><a class="el" href="output.html#project_log">project.log</a></li>
<li><a class="el" href="output.html#project_log_pvode">project.log_pvode</a></li>
<li><a class="el" href="output.html#project_log_pid">project.log_PID</a></li>
<li><a class="el" href="output.html#stdout">stdout</a></li>
<li><a class="el" href="output.html#project_9999">project.9999.*</a></li>
</ul>
<hr/>
<p>In the following "INP" stands for a four-digit integer. <br/>
 "project" stands for any project name defined as "-simName" in the configuration file <a class="el" href="input.html#input_allopt_txt">allopt.txt: simulation parameters</a> .</p>
<hr/>
<h2><a class="anchor" id="project_png">
project.INP.X.png</a></h2>
<p>The .png files are graphics files, which show a color coded snapshot of the magnetization. The slice plane through the model is defined in the configuration file <a class="el" href="input.html#input_allopt_txt">allopt.txt: simulation parameters</a> . The x-,y-, and z-component of the magnetization are stored in *.0.png, *.1.png, and *.2.png, respectively. It is color coded from red (M=-1) to blue (M=+1).</p>
<p>These graphics files can be viewed with any picture viewer or graphical web browser.</p>
<hr/>
<h2><a class="anchor" id="project_d">
project.INP.d</a></h2>
<p>The .d files contain the magnetization (or whatever is implemented in <a class="el" href="writedatadat_8c.html">writedatadat.c</a>) along the "sampling line". The "sampling line" is defined in the configuration file <a class="el" href="input.html#input_allopt_txt">allopt.txt: simulation parameters</a> .</p>
<hr/>
<h2><a class="anchor" id="project_datmsh">
project.INP.datmsh</a></h2>
<p>This file contains the Cartesian coordinates of the measurement points along the sampling line.</p>
<div class="fragment"><pre class="fragment">
  point_id  dist  x  y  z
</pre></div><ul>
<li><b>point_id:</b> simple id for numbering the measurement points</li>
<li><b>dist:</b> distance from the first measurement point (in units of the FE mesh)</li>
<li><b>x</b>, <b>y</b>, and <b>z:</b> Cartesian coordinates</li>
</ul>
<hr/>
<h2><a class="anchor" id="project_fedat">
project.INP.fedat</a></h2>
<p>This files contains some mesh related data in <a href="http://help.avs.com/Express/doc/help/reference/dvmac/UCD_Form.htm">UCD format</a>. The "mkinp.sh" script (cf. <a class="el" href="postprocessing.html#ucd_files">UCD/inp Files</a>) can be used to create a complete UCD file, which can be visualized as explained in section <a class="el" href="postprocessing.html">Postprocessing</a> .</p>
<h3><a class="anchor" id="node_data">
node data</a></h3>
<ul>
<li><b>id:</b> node id</li>
<li><b>vert_vol:</b> volume assigned to the node</li>
<li><b>proc:</b> processor to which the node is assigned</li>
</ul>
<h3><a class="anchor" id="element_data">
element data</a></h3>
<ul>
<li><b>id:</b> element id</li>
<li><b>proc:</b> processor to which the element is assigned</li>
<li><b>vol:</b> volume</li>
<li><b>prop:</b> property id</li>
<li><b>qual:</b> quality factor (cf. <a class="el" href="elevertvol_8c.html">elevertvol.c</a>)</li>
<li><b>a_x</b>, <b>a_y</b>, and <b>a_z:</b> Cartesian components of the anisotropy axis</li>
<li><b>K1:</b> first magnetocrystalline anisotropy constant (reduced units)</li>
<li><b>K2:</b> second magnetocrystalline anisotropy constant (reduced units)</li>
<li><b>Js:</b> saturation polarization (reduced units)</li>
<li><b>A:</b> exchange constant (reduced units)</li>
</ul>
<hr/>
<h2><a class="anchor" id="project_felog">
project.INP.felog</a></h2>
<p>This file contains a lot of useful information about the finite element mesh:</p>
<ul>
<li><b>simname:</b> project name</li>
<li><b>n_vert:</b> number of vertices</li>
<li><b>n_ele:</b> number of elements</li>
<li><b>n_fac:</b> number of triangular faces (all, also interior faces)</li>
<li><b>n_vert_bnd:</b> number of vertices on the boundary</li>
<li><b>n_ele_bnd:</b> number of elements on the boundary</li>
<li><b>n_bnd_fac:</b> number of triangular faces on the boundary</li>
<li><b>n_prop:</b> number of property ids (grains)</li>
</ul>
<ul>
<li><b>bounding box:</b> the smallest rectangular box surrounding the model</li>
<li><b>elevol:</b> element volumes: minimum, maximum, ratio, element ids, average, total volume</li>
<li><b>vertvol:</b> vertex volumes</li>
<li><b>edge_len:</b> minimum, maximum, and average of all edges (connection two vertices) in the finite element mesh</li>
<li><b>elequal:</b> minimum, maximum, and average of element quality factors</li>
<li><b>volume by property id:</b></li>
<li><b>average magnetization:</b> weighted with element volume</li>
</ul>
<hr/>
<h2><a class="anchor" id="project_femsh">
project.INP.femsh</a></h2>
<p>This file contains the finite element mesh in <a href="http://help.avs.com/Express/doc/help/reference/dvmac/UCD_Form.htm">UCD format</a>. Since the mesh does not change during the simulation, it is stored only once in this file and used by the "mkinp.sh" (cf. <a class="el" href="postprocessing.html#ucd_files">UCD/inp Files</a>) script to create complete UCD files.</p>
<hr/>
<h2><a class="anchor" id="project_gz">
project.INP.gz</a></h2>
<p>These files contain various simulation data (magnetization distribution, magnetostatic, anisotropy, exchange, external field) in <a href="http://help.avs.com/Express/doc/help/reference/dvmac/UCD_Form.htm">UCD format</a>. In order to save disk space (which becomes important for large models and long simulations with many output files) the mesh data is not included (it is stored only once in <a class="el" href="output.html#project_femsh">project.INP.femsh</a>) and the remaining data are compressed using zlib (gzip format) (if this option has been compiled in). The "mkinp.sh" script (cf. <a class="el" href="postprocessing.html#ucd_files">UCD/inp Files</a>) can be used to create a complete UCD file, which can be visualized as explained in section <a class="el" href="postprocessing.html">Postprocessing</a> .</p>
<p>The following data are stored in theses files:</p>
<ul>
<li><b>M_x :</b> x component of magnetization vector (dimensionless: magnetization vector normalized to 1)</li>
<li><b>M_y :</b> y component of magnetization vector (dimensionless: magnetization vector normalized to 1)</li>
<li><b>M_z :</b> z component of magnetization vector (dimensionless: magnetization vector normalized to 1)</li>
</ul>
<p>analogously the Cartesian components of</p>
<ul>
<li><b>Hdemag:</b>magnetostatic field (T)</li>
</ul>
<ul>
<li><b>Hani_x :</b>magnetocrystalline anisotropy field (T)</li>
<li><b>Hexch_x :</b>exchange field (T) <br/>
or</li>
<li><b>Hexchani_x:</b>exchange+magnetocrystalline anisotropy field (T)</li>
</ul>
<ul>
<li><b>Hext_x :</b>external field (T)</li>
</ul>
<p>The structure and contents can change depending on compilation and simulation options. E.g., if the magnetostatic field is switched of in the <a class="el" href="allopttxt.html">allopt.txt</a> file then the divergence and scalar magnetic potential are omitted. If the magpar executable has been compiled with the EXCH option, then the exchange and magnetocrystalline anisotropy field are saved separately. <hr/>
<h2><a class="anchor" id="project_inp_inp">
project.INP.inp</a></h2>
<p>Complete inp files (including the mesh information) are created by magpar if zlib compression is not supported (magpar is not linked with the zlib library) or magpar is compiled in the Cygwin environment under Windows. These complete inp files can be immediately visualized as explained in section <a class="el" href="postprocessing.html">Postprocessing</a> .</p>
<p>Otherwise these complete inp files can be generated from <a class="el" href="output.html#project_femsh">project.INP.femsh</a> and <a class="el" href="output.html#project_gz">project.INP.gz</a> as described in <a class="el" href="postprocessing.html#ucd_files">UCD/inp Files</a>.</p>
<hr/>
<h2><a class="anchor" id="project_log">
project.log</a></h2>
<p>This log file contains the most important simulation data in a columnar format. magpar always appends new data to the end of the file if it does already exit. This useful feature is used in example <a class="el" href="examples.html#mumag3">mumag3: mumag standard problem #3</a> and <a class="el" href="examples.html#sphere_sw">sphere_sw: Stoner-Wohlfarth behavior</a> .</p>
<p><b>columns:</b></p>
<ul>
<li><b>eq:</b> &gt;=1 if the system has reached equilibrium, i.e. mx|dM/dt| is smaller than the threshold -tol (defined in <a class="el" href="input.html#input_allopt_txt">allopt.txt: simulation parameters</a>) (see below); if the system is in equilibrium for successive iterations this counter is increased; it is reset to zero as soon as the system is not in equilibrium</li>
<li><b>inp:</b> number of the corresponding UCD (.inp), .png, .d output files</li>
<li><b>time:</b> simulated time</li>
<li><b>Hext:</b> external field (sum of contributions from all external field sources)</li>
<li><b>Etot:</b> total energy</li>
<li><b>J//Hext:</b> reduced average polarization parallel to the external field</li>
<li><b>Mx</b>, <b>My</b>, and <b>Mz:</b> Cartesian components of the average magnetization (not weighted with Js!)</li>
<li><b>Edem:</b> magnetostatic (=demag=stray field) energy</li>
<li><b>Exchani:</b> exchange+anisotropy energy</li>
<li><b>Eext:</b> Zeeman energy</li>
<li><b>devNorm:</b> maximum deviation of the norm of the reduced magnetization |M| on any node from 1.0</li>
<li><b>mx|dM/dt|:</b> maximum of |dM/dt|, the difference quotient of M with respect to the last time step dt ("torque") on any node</li>
<li><b>timestep:</b> time step</li>
<li><b>tCPU:</b> elapsed time ("wall clock time")</li>
<li><b>CPUtstep:</b> CPU time ("wall clock time") required for the last time step</li>
</ul>
<hr/>
<h2><a class="anchor" id="project_log_pvode">
project.log_pvode</a></h2>
<p>SUNDIALS/PVODE data:</p>
<ul>
<li><b>time:</b> simulated time</li>
<li><b>nstep:</b> number of time steps</li>
<li><b>qu:</b> integration order</li>
<li><b>nfe:</b> number of calls to the user's f function (i.e. <a class="el" href="rhsfunction_8c.html#a5e964b5572e1640d9a793c353f6a28f6">RHSfunction</a>, <a class="el" href="llg_8h.html#aa814b25d7c7a65198ca75426fb6d7403">calc_dMdt</a>)</li>
<li><b>nni:</b> number of (non-linear) Newton iterations</li>
<li><b>ncfn:</b> number of nonlinear convergence failures</li>
<li><b>nli:</b> number of linear iterations of CVSPGMR solver</li>
<li><b>npe:</b> number of preconditioner evaluations</li>
<li><b>nps:</b> number of calls to <a class="el" href="precond_8c.html#a26a82305d86917d32992af0031acd675">PSolve</a></li>
<li><b>ncfl:</b> number of linear convergence failures</li>
</ul>
<hr/>
<h2><a class="anchor" id="project_log_pid">
project.log_PID</a></h2>
<p>These log files list the total energy, average magnetization and field, magnetostatic, anisotropy, exchange and Zeeman energy separately for each volume with the property id PID.</p>
<hr/>
<h2><a class="anchor" id="stdout">
stdout</a></h2>
<p>A lot of information is sent to stdout during the simulation:</p>
<ul>
<li>magpar version, library versions, included features</li>
<li>settings of the most important parameters</li>
<li>scaling factors for field, time, and energy</li>
<li>material parameters, anisotropy field, exchange lengths, Larmor frequencies</li>
<li>size of the boundary matrix</li>
<li>sampling line and slice plane data</li>
<li>solver output</li>
<li>exit conditions</li>
<li>etc.</li>
</ul>
<p>See <a class="el" href="input.html#input_allopt_txt">allopt.txt: simulation parameters</a> and the PETSc manual for more.</p>
<hr/>
<h2><a class="anchor" id="project_9999">
project.9999.*</a></h2>
<p>Every 2000 seconds (33 minutes) a full set of output files is written. This allows to check the progress of the simulation even if the cond_inp parameters in <a class="el" href="input.html#input_allopt_txt">allopt.txt: simulation parameters</a> have been set to disable any output. Even more important, it is a checkpointing type behavior since one can restart the simulation from the UCD file ( <a class="el" href="output.html#project_gz">project.INP.gz</a>) if the program or one of the executing machines have crashed. </p>
</div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

